<?php
class ControllerModuleBatchCustomerGroupSpecials extends Controller {
	private $error = array();

	public function index() {
		$this->load->language('module/batch_customer_group_specials');

		$this->document->setTitle($this->language->get('heading_title'));

		$this->load->model('setting/setting');

		if (($this->request->server['REQUEST_METHOD'] == 'POST') && ($this->validate())) {
			$this->model_setting_setting->editSetting('batch_customer_group_specials', $this->request->post);
			$this->session->data['success'] = $this->language->get('text_success');
			$this->response->redirect($this->url->link('module/batch_customer_group_specials', 'token=' . $this->session->data['token'], 'SSL'));
		}

		if (isset($this->request->get['refresh']) && ($this->validate())) {
			$this->load->model('module/batch_customer_group_specials');
			$this->model_module_batch_customer_group_specials->setCustomerGroupDiscountsToAllProducts($this->config->get('batch_customer_group_specials'));
			$this->session->data['success'] = $this->language->get('text_success_updated');
			$this->response->redirect($this->url->link('module/batch_customer_group_specials', 'token=' . $this->session->data['token'], 'SSL'));
		}

		if (isset($this->request->get['clear']) && ($this->validate())) {
			$this->load->model('module/batch_customer_group_specials');
			$this->model_module_batch_customer_group_specials->clearCustomerGroupDiscountsToAllProducts();
			$this->session->data['success'] = $this->language->get('text_success_cleared');
			$this->response->redirect($this->url->link('module/batch_customer_group_specials', 'token=' . $this->session->data['token'], 'SSL'));
		}

		if(isset($this->session->data['success'])){
			$data['success'] = $this->session->data['success'];
			unset($this->session->data['success']);
		}else{
			$data['success'] = '';
		}

		$data['heading_title'] = $this->language->get('heading_title');

        $data['text_edit'] = $this->language->get('heading_title');
 		$data['entry_discount'] = $this->language->get('entry_discount');
 		$data['help_discount'] = $this->language->get('help_discount');
		$data['text_help'] = $this->language->get('text_help');

		$data['button_save'] = $this->language->get('button_save');
		$data['button_refresh'] = $this->language->get('button_refresh');
		$data['button_clear'] = $this->language->get('button_clear');
		$data['button_cancel'] = $this->language->get('button_cancel');

		if (isset($this->error['warning'])) {
			$data['error_warning'] = $this->error['warning'];
		} else {
			$data['error_warning'] = '';
		}

		$data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_home'),
			'href'      => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => false
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('text_module'),
			'href'      => $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['breadcrumbs'][] = array(
			'text'      => $this->language->get('heading_title'),
			'href'      => $this->url->link('module/batch_customer_group_specials', 'token=' . $this->session->data['token'], 'SSL'),
			'separator' => ' :: '
		);

		$data['action'] = $this->url->link('module/batch_customer_group_specials', 'token=' . $this->session->data['token'], 'SSL');
		$data['refresh'] = $this->url->link('module/batch_customer_group_specials', 'refresh=true&token=' . $this->session->data['token'], 'SSL');
		$data['clear'] = $this->url->link('module/batch_customer_group_specials', 'clear=true&token=' . $this->session->data['token'], 'SSL');

		$data['cancel'] = $this->url->link('extension/module', 'token=' . $this->session->data['token'], 'SSL');


		$this->load->model('customer/customer_group');
		$customer_groups = $this->model_customer_customer_group->getCustomerGroups(array('sort' => 'cg.sort_order'));
		$discounts = $this->config->get('batch_customer_group_specials');

		foreach($customer_groups as $key => $group){
			if(isset($discounts[$group['customer_group_id']])){
				$customer_groups[$key] = array_merge($customer_groups[$key], $discounts[$group['customer_group_id']]);
			}else{
				$customer_groups[$key] = array_merge($customer_groups[$key], array('discount' => 0, "start_date" => "", "end_date" => ""));
			}
		}

		$data['customer_groups'] = $customer_groups;


		$data['header'] = $this->load->controller('common/header');
		$data['column_left'] = $this->load->controller('common/column_left');
		$data['footer'] = $this->load->controller('common/footer');

		$this->response->setOutput($this->load->view('module/batch_customer_group_specials.tpl', $data));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'module/batch_customer_group_specials')) {
			$this->error['warning'] = $this->language->get('error_permission');
		}

		if (!$this->error) {
			return true;
		} else {
			return false;
		}
	}

}
?>